#include<stdio.h>

int main(){

  int n;

  /* 下で定義される関数のプロトタイプを宣言 */
  double factorial(int);

  
  for(n=0;n<31;n++){

    printf("n = %d, n! = %f\n", n, factorial(n)); // factorial関数を使って階乗を計算
        
  }

  return 0;
  
} /* メインのプログラムはここまで */


/* 階乗を計算して倍精度実数を返す関数、引数は整数型のn*/
double factorial(int n){
    
  int k;
  double fact; // 階乗の値をセットするための倍精度実数型変数

  /* 階乗ではn>=0でしか計算できないので負の数が入力されたときのエラー処理 */
  fact = 0.0;
  if(n<0) return(fact); // n<0であればfact(ゼロ)を返してこの関数を終了
 
  fact = 1.0; // 初期値1をセット
  if(n==0) return(fact); // n=0の場合は0!=1なので1を返して関数を終了

  /* ここまで来る処理はnが正の場合 */

  /* 通常の方法で階乗を倍精度実数として計算 */
  for(k=1;k<n+1;k++){

    fact *= (double) k;

  }
    
  return(fact); // n>0の場合は上のforループで計算されたfactの値を返す

}
